sound_dpcm:
	lda	channel_sel
	asl	a
	tax
	dec	sound_counter,x		;JE^炵
	bne	.dpcm_end
	jsr	sound_dpcm_play
.dpcm_end
	rts

sound_dpcm_play:
	jsr	reg400x

	lda	sound_bank,x
	jsr	change_bank

	lda	[sound_add_low,x]
;----------
;[v1
	cmp	#$a0
	bne	dmc_loop_program2
	jsr	loop_sub
	jmp	sound_dpcm_play
;----------
;[v2()
dmc_loop_program2
	cmp	#$a1
	bne	dmc_bank_command
	jsr	loop_sub2
	jmp	sound_dpcm_play
;----------
;oN؂ւ
dmc_bank_command
	cmp	#$ee
	bne	dmc_data_end
	jsr	data_bank_addr
	jmp	sound_dpcm_play
;----------
dmc_data_end:
	cmp	#$ff
	bne	no_dpcm
	jsr	data_end_sub
	jmp	sound_dpcm_play
;----------
no_dpcm:
	cmp	#$fc
	bne	wait_set2
	.if	DPCM_RESTSTOP
	lda	#$0F		;2sLɂ
	sta	$4015		;rDPCM~
	.endif
	jmp	ontyou2

wait_set2:
	cmp	#$f4
	bne	dpcm_set
	jsr	wait_sub
	rts

dpcm_set:
	asl	a
	asl	a
	tax

	pha
	lda	#$0F
	sta	$4015
;;;;;;;;;;  "MCK virtual keyboard" by Norix
;	lda	#$FF		; 炷I
;	sta	$07A0+4*2	; xtOgႤ[
;;;;;;;;;;
	pla

	lda	dpcm_data,x		;DPCM control
	sta	$4010
	inx	
	lda	dpcm_data,x		;DPCM delta counter initialize
	cmp	#$FF
	beq	.skip
	sta	$4011
.skip
	inx	
	lda	dpcm_data,x		;DPCM address set
	sta	$4012
	inx	
	lda	dpcm_data,x		;DPCM length set
	sta	$4013

	lda	#$1F
	sta	$4015

ontyou2:
	jsr	reg400x
	jsr	sound_data_address
	lda	[sound_add_low,x]
	sta	sound_counter,x
	jsr	sound_data_address
	rts
